#include "ot4xb.ch"
// ---------------------------------------------------------------------------
#xtranslate @dh:<f>( [<params,...>] )   => @disphpr:<f>( [<params>] )
// ---------------------------------------------------------------------------
#xtranslate SAFE_RELEASE( <v> ) => (<v> := iif(Empty(<v>),0,(IFpQCall(2,"__sl__sl",<v>),0)))
                                 ; 
// ---------------------------------------------------------------------------
#xtranslate HR_TRY(<exp>) => iif( <exp> \< 0,(QOut("Fatal Error On Line ",__LINE__),Break()),)
// ---------------------------------------------------------------------------
#xtranslate L(<c>)  => cSzAnsi2Wide(<c>)
// ---------------------------------------------------------------------------
proc main()                                                          
? "Running Excel Sample One..."
ExcelSample1()
//? "Press any key to run Excel Sample Two..."
//inkey(0)
//ExcelSample2()
? "Done! Press any key to exit... "
inkey(0)
return 
// ---------------------------------------------------------------------------
function ExcelSample1()
local xlApp     := 0
local xlRange   := 0
local xlChart   := 0
local i         := 0
local aHeadings := {"Mammals","Birds","Reptiles","Fishes","Plants"}
local xlCells   := 0
local xlSheet   := 0

@dh:dhInitializeImp(.T.,.T.)
@dh:dhToggleExceptions(.T.)
BEGIN SEQUENCE
   HR_TRY( @dh:dhCreateObject(L("Excel.Application"),0,@xlApp) )
   @dh:dhPutValue(xlApp, L(".DisplayFullScreen = %b"), .T.)
   @dh:dhPutValue(xlApp, L(".Visible = %b"), .T.)
   
   // xlApp.Workbooks.Add
   HR_TRY( @dh:dhCallMethod(xlApp, L(".Workbooks.Add") ) )
	// Set the worksheet name
	
	@dh:dhPutValue(xlApp, L(".ActiveSheet.Name = %s"),"Critically Endangered")
	// Add the column headings
	aEval( aHeadings , {|_e,_n|  @dh:dhPutValue(xlApp,L(".ActiveSheet.Cells(%d, %d) = %S"),1,_n,L(_e))} )

	//  Format the headings
	if( @dh:dhGetValue(L("%o"),@xlCells,xlApp,L(".ActiveSheet.Range(%s)"),"A1:E1") >= 0 )
		@dh:dhPutValue(xlCells, L(".Interior.Color = %d"),@ot4xb:ot4xb_RGB(0xee,0xdd,0x82))
		@dh:dhPutValue(xlCells, L(".Interior.Pattern = %d"), 1) // xlSolid
		@dh:dhPutValue(xlCells, L(".Font.Size = %d"), 13)
		@dh:dhPutValue(xlCells, L(".Borders.Color = %d"),0)
		@dh:dhPutValue(xlCells, L(".Borders.LineStyle = %d"), 1) // xlContinuous
		@dh:dhPutValue(xlCells, L(".Borders.Weight = %d"), 2) // xlThin
      SAFE_RELEASE( xlCells)
   end

	if( @dh:dhGetValue(L("%o"),@xlSheet,xlApp,L(".ActiveSheet")) >= 0 )
	   // Set some values
		@dh:dhPutValue(xlSheet, L(".Range(%s).Value = %d"), "A2", 184)
		@dh:dhPutValue(xlSheet, L(".Range(%s).Value = %d"), "B2", 182)
		@dh:dhPutValue(xlSheet, L(".Range(%s).Value = %d"), "C2", 57)
		@dh:dhPutValue(xlSheet, L(".Range(%s).Value = %d"), "D2", 162)
		@dh:dhPutValue(xlSheet, L(".Range(%s).Value = %d"), "E2", 1276)
      // Output data source
		@dh:dhCallMethod(xlSheet, L(".Range(%s).Merge"),"A4:E4")
		@dh:dhPutValue( xlSheet, L(".Range(%s).Value = %s"),"A4",;
		                "Source: IUCN Red List 2003 "+;
		                "(http://www.redlist.org/info/tables/table2.html)")
		// Apply a border around everything. Note '%m' means missing.
		@dh:dhCallMethod(xlSheet, L(".Range(%s).BorderAround(%d, %d, %m, %d)"), "A1:E2", 1, 2,0)
		// Set column widths
		@dh:dhPutValue(xlSheet, L(".Columns(%s).ColumnWidth = %e"), "A:E", NIL,12.5)
      SAFE_RELEASE( xlSheet )
   end

	// Set xlRange = xlApp.ActiveSheet.Range("A1:E2")
	HR_TRY( @dh:dhGetValue(L("%o"),@xlRange,xlApp,L(".ActiveSheet.Range(%s)"), "A1:E2"))
	// Set xlChart = xlApp.ActiveWorkbook.Charts.Add
	HR_TRY( @dh:dhGetValue(L("%o"),@xlChart,xlApp,L(".ActiveWorkbook.Charts.Add")) )
	// Set up the chart
	@dh:dhCallMethod( xlChart, L(".ChartWizard(%o, %d, %d, %d, %d, %d, %b, %s)"),;
	                  xlRange,-4100, 7, 1, 1, 0,.F.,"Critically Endangered Plants and Animals")
	@dh:dhPutValue(xlChart, L(".HasAxis(%d) = %b"), 3,.F.) // xlSeries
	// Put the chart on our worksheet
	@dh:dhCallMethod(xlChart, L(".Location(%d,%s)"), 2, "Critically Endangered")
END SEQUENCE
@dh:dhToggleExceptions(.F.)
@dh:dhPutValue(xlApp, L(".ActiveWorkbook.Saved = %b"),.T.)
SAFE_RELEASE(xlRange)
SAFE_RELEASE(xlChart)
SAFE_RELEASE(xlApp)
@dh:dhUninitialize(.T.)
return NIL

